## libmpack 1.0.2

=== debian/changelog ===
libmpack (1.0.2-2) unstable; urgency=medium

  * Add test/deps to d/copyright.

 -- James McCoy <jamessan@debian.org>  Sat, 25 Jun 2016 22:42:00 -0400

libmpack (1.0.2-1) unstable; urgency=medium

  * Initial release.

 -- James McCoy <jamessan@debian.org>  Sat, 18 Jun 2016 15:10:06 -0400
