=== debian/changelog ===
libmpack (1.0.3-1) unstable; urgency=medium

  * New upstream release
    + Drop all backported patches.

 -- James McCoy <jamessan@debian.org>  Fri, 16 Dec 2016 21:16:46 -0500
