=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%libmpack-$1.tar.gz%" \
    https://github.com/tarruda/libmpack/tags \
    (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
