=== debian/changelog ===
libmpack (1.0.5-2) unstable; urgency=medium

  * Upload to unstable

 -- James McCoy <jamessan@debian.org>  Sat, 22 Jul 2017 21:49:43 -0400

libmpack (1.0.5-1) experimental; urgency=medium

  * New upstream release
    + Update URLs for move to https://github.com/libmpack/libmpack/
  * Remove everything lua, since that has been separated into a distinct
    project.

 -- James McCoy <jamessan@debian.org>  Sun, 30 Apr 2017 15:17:04 -0400
