=== debian/control ===
--- 
+++ 
@@ -3,10 +3,9 @@
 Priority: extra
 Maintainer: James McCoy <jamessan@debian.org>
 Build-Depends: debhelper (>= 9),
-               dh-lua,
                libtool-bin,
 Standards-Version: 3.9.8
-Homepage: https://github.com/tarruda/libmpack/
+Homepage: https://github.com/libmpack/libmpack/
 Vcs-Git: https://anonscm.debian.org/git/collab-maint/libmpack.git
 Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/libmpack.git
 
@@ -46,16 +45,3 @@
   * No allocation performed by the library, but helpers to simplify dynamic
     allocation if the application needs it.
   * Non-backtracking, incremental/iterative parse/serialization API
-
-Package: lua-mpack
-Architecture: any
-Pre-Depends: ${misc:Pre-Depends}
-Multi-Arch: same
-Depends: ${misc:Depends}, ${shlibs:Depends}
-Provides: ${lua:Provides}
-XB-Lua-Versions: ${lua:Versions}
-Description: small binary serialization/RPC library (lua bindings)
- libmpack is a small binary serialization/RPC library that implements both the
- msgpack and msgpack-rpc specifications.
- .
- This package provides the Lua bindings based on libmpack.
