=== debian/rules ===
--- 
+++ 
@@ -16,16 +16,13 @@
 ARGS = config=$(CONFIG) VERBOSE=1 PREFIX=/usr LIBDIR=/usr/lib/$(DEB_HOST_MULTIARCH)
 
 %:
-	dh $@ --with lua --buildsystem=lua --parallel
+	dh $@ --parallel
 
 override_dh_auto_build-arch:
 	$(MAKE) $(ARGS)
-	dh_auto_build --buildsystem=lua -plua-mpack
 
 override_dh_auto_install-arch:
 	$(MAKE) $(ARGS) DESTDIR=$(CURDIR)/debian/tmp install
-	dh_auto_install --buildsystem=lua -plua-mpack
 
 override_dh_auto_test:
 	$(MAKE) VERBOSE=1 test
-# Need busted packaged to run tests for Lua module
